﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sidebar
{
    /// <summary>
    /// Interaktionslogik für AppIcon.xaml
    /// </summary>
    public partial class AppIcon : UserControl
    {
        private ApplicationUserItem connectedApp;

        public AppIcon()
        {
            InitializeComponent();
        }

        public event EventHandler<MouseEventArgs> BinClicked;
        public event EventHandler<MouseEventArgs> Clicked;

        public string Text
        {
            get
            {
                return txtTitle.Text;
            }
            set
            {
                txtTitle.Text = value;
            }
        }

        public ImageSource Icon
        {
            get
            {
                return content.Source;
            }
            set
            {
                content.Source = value;
            }
        }

        public bool ShowBin
        {
            get
            {
                return binCan.Visibility == Visibility.Visible;
            }
            set
            {
                if(value)
                {
                    binCan.Visibility = Visibility.Visible;
                }
                else
                {
                    binCan.Visibility = Visibility.Hidden;
                }
            }
        }

        public ApplicationUserItem ConnectedApp
        {
            get
            {
                return connectedApp;
            }
            set
            {
                connectedApp = value;
            }
        }

        private void binCan_MouseUp(object sender, MouseButtonEventArgs e)
        {
            if(ShowBin)
            {
                BinClicked?.Invoke(this, e);
                e.Handled = true;
            }
        }

        private void Grid_MouseUp(object sender, MouseButtonEventArgs e)
        {
            if(!e.Handled)
            {
                Clicked?.Invoke(this, e);
            }
        }
    }
}
