﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace Sidebar
{
    [Serializable]
    public class ApplicationUserItem
    {
        private string name;
        private string path;
        private string arguments;
        private bool useEmbededIcon;

        public string Name
        {
            get
            {
                return name;
            }

            set
            {
                name = value;
            }
        }

        public string Path
        {
            get
            {
                return path;
            }

            set
            {
                path = value;
            }
        }

        public string Arguments
        {
            get
            {
                return arguments;
            }

            set
            {
                arguments = value;
            }
        }

        public bool UseEmbeddedIcon
        {
            get
            {
                return useEmbededIcon;
            }

            set
            {
                useEmbededIcon = value;
            }
        }

        public ImageSource GetImage()
        {
            return IconToImageSource(Icon.ExtractAssociatedIcon(this.Path));
        }

        public ApplicationUserItem()
        {
            name = "";
            path = "";
            arguments = "";
            useEmbededIcon = true;
        }

        public static ImageSource IconToImageSource(Icon icon)
        {
            ImageSource imageSource = BitmapImageConverter.IconToBitmapImage(icon);

            return imageSource;
        }
    }
}
