﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Xml.Serialization;

namespace Sidebar
{
    public class Config
    {
        public static event EventHandler AccentColorChanged;

        private static string filename = "Side.Configuration.xml";

        private static ConfigHolder holder = null;
        private static ConfigHolder Holder
        {
            get
            {
                if (holder == null) LoadConfig();

                return holder;
            }
            set
            {
                holder = value;
            }
        }

        [Serializable]
        public class ConfigHolder
        {
            public Color accentColor = Color.FromRgb(244, 244, 245);

            public List<ApplicationUserItem> applications = new List<ApplicationUserItem>();

            public int animationSpeed = 300;
            public bool collapseAfterRun = true;

            public bool useHotkey = true;
            public bool useHotKeyCtrl = true;
            public bool useHotKeyShift = true;
            public KeyboardHook.VKeys useHotkeyKey = KeyboardHook.VKeys.KEY_Y;
        }
       
        public static Color AccentColor
        {
            get
            {
                return Holder.accentColor;
            }
            set
            {
                Holder.accentColor = value;
                AccentColorChanged?.Invoke(null, null);
            }
        }
        public static List<ApplicationUserItem> Applications
        {
            get
            {
                return Holder.applications;
            }
            set
            {
                Holder.applications = value;
            }
        }
        public static int AnimationSpeed
        {
            get
            {
                return Holder.animationSpeed;
            }
            set
            {
                Holder.animationSpeed = value;
            }
        }
        public static bool CollapseAfterRun
        {
            get
            {
                return Holder.collapseAfterRun;
            }
            set
            {
                Holder.collapseAfterRun = value;
            }
        }
        public static bool UseHotKey
        {
            get
            {
                return Holder.useHotkey;
            }
            set
            {
                Holder.useHotkey = value;
            }
        }
        public static bool UseHotKeyCtrl
        {
            get
            {
                return Holder.useHotKeyCtrl;
            }
            set
            {
                Holder.useHotKeyCtrl = value;
            }
        }
        public static bool UseHotKeyShift
        {
            get
            {
                return Holder.useHotKeyShift;
            }
            set
            {
                Holder.useHotKeyShift = value;
            }
        }
        public static KeyboardHook.VKeys UseHotKeyKey
        {
            get
            {
                return Holder.useHotkeyKey;
            }
            set
            {
                Holder.useHotkeyKey = value;
            }
        }

        public static void LoadConfig()
        {
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(ConfigHolder));

                using (FileStream stream = new FileStream(filename, FileMode.OpenOrCreate))
                {
                    holder = (ConfigHolder) serializer.Deserialize(stream);
                }
            }
            catch (Exception)
            {
                holder = new ConfigHolder();
            }
        }
        public static void SaveConfig()
        {
            XmlSerializer serializer = new XmlSerializer(typeof(ConfigHolder));

            using (FileStream stream = new FileStream(filename, FileMode.OpenOrCreate))
            {
                serializer.Serialize(stream, holder);
            }
        }
    }
}
