﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sidebar
{
    public static class ShortcutReader
    {
        public static Shortcut GetShortcutInfo(string fullName)
        {
            try
            {
                // Make a Shell object.
                Shell32.Shell shell = new Shell32.Shell();

                // Get the shortcut's folder and name.
                string shortcutPath = fullName.Substring(0, fullName.LastIndexOf("\\"));
                string ShortcutName = fullName.Substring(fullName.LastIndexOf("\\") + 1);
                if (!ShortcutName.EndsWith(".lnk")) ShortcutName += ".lnk";

                // Get the shortcut's folder.
                Shell32.Folder shortcutFolder = shell.NameSpace(shortcutPath);

                // Get the shortcut's file.
                Shell32.FolderItem folderItem = shortcutFolder.Items().Item(ShortcutName);

                // Display the shortcut's information.
                Shell32.ShellLinkObject lnk = (Shell32.ShellLinkObject) folderItem.GetLink;

                return new Shortcut(folderItem.Name, lnk.Path, lnk.Description, lnk.WorkingDirectory, lnk.Arguments);
            }
            catch (Exception)
            {
                return new Shortcut(Path.GetFileNameWithoutExtension(fullName), fullName, "", "", "");
            }
        }

        public static bool IsShortcut(string fullName)
        {
            try
            {
                // Make a Shell object.
                Shell32.Shell shell = new Shell32.Shell();

                // Get the shortcut's folder and name.
                string shortcutPath = fullName.Substring(0, fullName.LastIndexOf("\\"));
                string ShortcutName = fullName.Substring(fullName.LastIndexOf("\\") + 1);
                if (!ShortcutName.EndsWith(".lnk")) ShortcutName += ".lnk";

                // Get the shortcut's folder.
                Shell32.Folder shortcutFolder = shell.NameSpace(shortcutPath);

                // Get the shortcut's file.
                Shell32.FolderItem folderItem = shortcutFolder.Items().Item(ShortcutName);

                return folderItem.IsLink;
            }
            catch (Exception)
            {
                return false;
            }
        }
    }

    public class Shortcut
    {
        private string name, path, description, workingDir, arguments;

        public Shortcut(string name, string path, string description, string workingDir, string arguments)
        {
            this.name = name;
            this.path = path;
            this.description = description;
            this.workingDir = workingDir;
            this.arguments = arguments;
        }

        public string Arguments
        {
            get
            {
                return arguments;
            }

            set
            {
                arguments = value;
            }
        }

        public string Description
        {
            get
            {
                return description;
            }

            set
            {
                description = value;
            }
        }

        public string Name
        {
            get
            {
                return name;
            }

            set
            {
                name = value;
            }
        }

        public string Path
        {
            get
            {
                return path;
            }

            set
            {
                path = value;
            }
        }

        public string WorkingDir
        {
            get
            {
                return workingDir;
            }

            set
            {
                workingDir = value;
            }
        }
    }
}
