﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Sidebar
{
    /// <summary>
    /// Interaktionslogik für SettingsWindow.xaml
    /// </summary>
    public partial class SettingsWindow : Window
    {
        public SettingsWindow()
        {
            InitializeComponent();

            hook = new KeyboardHook();
            hook.KeyDown += Hook_KeyDown;
        }

        private KeyboardHook hook;

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            slAnimSpeed.Value = Config.AnimationSpeed;
            chkCollapseAfterRun.IsChecked = Config.CollapseAfterRun;
            textBox.Text = Config.UseHotKeyKey.ToString();
            chkHotkeyCtrl.IsChecked = Config.UseHotKeyCtrl;
            chkHotkeyShift.IsChecked = Config.UseHotKeyShift;
            chkHotkeyCollapseExpand.IsChecked = Config.UseHotKey;
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            hook.Uninstall();

            Config.AnimationSpeed = (int) slAnimSpeed.Value;
            Config.CollapseAfterRun = chkCollapseAfterRun.IsChecked.Value;

            Config.UseHotKey = chkHotkeyCollapseExpand.IsChecked.Value;
            Config.UseHotKeyCtrl = chkHotkeyCtrl.IsChecked.Value;
            Config.UseHotKeyShift = chkHotkeyShift.IsChecked.Value;

            Config.SaveConfig();
        }

        private void Grid_MouseUp(object sender, MouseButtonEventArgs e)
        {
            Config.AccentColor = ((sender as Grid).Background as SolidColorBrush).Color;
        }

        #region Keyboard
        private void textBox_GotKeyboardFocus(object sender, KeyboardFocusChangedEventArgs e)
        {
            hook.Install();
        }

        private void Hook_KeyDown(KeyboardHook.VKeys key)
        {
            Config.UseHotKeyKey = key;
            textBox.Text = key.ToString();
            hook.Uninstall();
        }

        private void textBox_LostKeyboardFocus(object sender, KeyboardFocusChangedEventArgs e)
        {
            hook.Uninstall();
        } 
        #endregion
    }
}
